<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">

    <title>dez-canvas test</title>

    <script src="../../webcomponentsjs/webcomponents-lite.js"></script>
    <script src="../../web-component-tester/browser.js"></script>
    <script src="utils.js"></script>

    <link rel="import" href="../dez-canvas.html">
  </head>
  <body>

    <test-fixture id="ChangedPropertyTestFixture">
      <template>
        <dez-canvas bg="../demo/magritte.jpg"></dez-canvas>
      </template>
    </test-fixture>

    <script>

    const VL_WIDTH = 10;
    const VL_TEXT_HEIGHT = 15;

    suite ('Gestures tests', function () {

        setup (function () {
            this._element = fixture('ChangedPropertyTestFixture');
            this.leftMargin = getLeftMargin(this._element);
            this.HORIZONTAL_MARGIN = 10;
            this.timeout = 100;
        })

        test('tap on background should create a VerticalLine', function(done) {
            setTimeout(() => {
                let imageElement = new GesturesListenerElement(this._element.shadowRoot.querySelector('svg>image'));
                imageElement.longTapAt(100, 100, () => {
                  let textElement = this._element.shadowRoot.querySelector("svg>g>text")
                  assert.equal(textElement.innerHTML, "vline");
                  let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
                  assert.equal(rectElement.getAttribute("x"), 100 - VL_WIDTH/2 - this.leftMargin)
                  assert.equal(rectElement.getAttribute("y"), 25)
                  assert.equal(rectElement.getAttribute("width"), VL_WIDTH - 2)
                  assert.equal(rectElement.getAttribute("height"), 300)
                  done();
                })
            }, this.timeout);
        });

        test ('short track to the right on background should create a VerticalLine', function (done) {
            setTimeout(function () {
                let imageElement = new GesturesListenerElement(this._element.shadowRoot.querySelector('svg>image'));
                imageElement.longTapAt(200,100, () => {
                  imageElement.trackAt(200,100).moveTo(210,100).stop();
                  let textElement = this._element.shadowRoot.querySelector("svg>g>text")
                  assert.equal(textElement.innerHTML, "vline");
                  let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
                  assert.equal(rectElement.getAttribute("x"), 200 - VL_WIDTH/2 - this.leftMargin)
                  assert.equal(rectElement.getAttribute("y"), 25)
                  assert.equal(rectElement.getAttribute("width"), VL_WIDTH - 2)
                  assert.equal(rectElement.getAttribute("height"), 300 - VL_TEXT_HEIGHT)
                  done();
                })
            }.bind(this), this.timeout);
        })

        test ('track to the right on background should create a small Rectangle without text', function (done) {
            setTimeout(function () {
                let imageElement = new GesturesListenerElement(this._element.shadowRoot.querySelector('svg>image'));
                imageElement.longTapAt(200,100, () => {
                  imageElement.trackAt(200,100).moveTo(200+40,100).stop();
                  let textElement = this._element.shadowRoot.querySelector("svg>g>text")
                  assert.equal(textElement.getAttribute("x"), -100);
                  let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
                  assert.equal(rectElement.getAttribute("x"), 200 - this.leftMargin - this.HORIZONTAL_MARGIN)
                  assert.equal(rectElement.getAttribute("y"), 25)
                  assert.equal(rectElement.getAttribute("width"), 40 + 2*this.HORIZONTAL_MARGIN - 2)
                  assert.equal(rectElement.getAttribute("height"), 300)
                  done();
                })
            }.bind(this), this.timeout);
        })

        test ('long track to the right on background should create a Rectangle with text inside', function (done) {
            setTimeout(function () {
                let imageElement = new GesturesListenerElement(this._element.shadowRoot.querySelector('svg>image'));
                imageElement.longTapAt(200,100, () => {
                  imageElement.trackAt(200,100).moveTo(350,100).stop();
                  let textElement = this._element.shadowRoot.querySelector("svg>g>text")
                  assert.equal(textElement.innerHTML, "rectangle");
                  let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
                  assert.equal(rectElement.getAttribute("x"), 200 - this.leftMargin - this.HORIZONTAL_MARGIN)
                  assert.equal(rectElement.getAttribute("y"), 25)
                  assert.equal(rectElement.getAttribute("width"), 150 + 2*this.HORIZONTAL_MARGIN - 2)
                  assert.equal(rectElement.getAttribute("height"), 300)
                  done();
                })
            }.bind(this), this.timeout);
        })

        test ('short track to the left on background should create a VerticalLine', function (done) {
            setTimeout(function () {
                let imageElement = new GesturesListenerElement(this._element.shadowRoot.querySelector('svg>image'));
                imageElement.longTapAt(200,100, () => {
                  imageElement.trackAt(200,100).moveTo(190,100).stop();
                  let textElement = this._element.shadowRoot.querySelector("svg>g>text")
                  assert.equal(textElement.innerHTML, "vline");
                  let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
                  assert.equal(rectElement.getAttribute("x"), 200 - VL_WIDTH/2 - this.leftMargin)
                  assert.equal(rectElement.getAttribute("y"), 25)
                  assert.equal(rectElement.getAttribute("width"), VL_WIDTH - 2)
                  assert.equal(rectElement.getAttribute("height"), 300 - VL_TEXT_HEIGHT)
                  done();
                })
            }.bind(this), this.timeout);
        })

        test ('track to the left on background should create a small Rectangle without text', function (done) {
            setTimeout(function () {
                let imageElement = new GesturesListenerElement(this._element.shadowRoot.querySelector('svg>image'));
                imageElement.longTapAt(200,100, () => {
                  imageElement.trackAt(200,100).moveTo(200-40,100).stop();
                  let textElement = this._element.shadowRoot.querySelector("svg>g>text")
                  assert.equal(textElement.getAttribute("x"), -100);
                  let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
                  assert.equal(rectElement.getAttribute("x"), 200 - 40 - this.leftMargin - this.HORIZONTAL_MARGIN)
                  assert.equal(rectElement.getAttribute("y"), 25)
                  assert.equal(rectElement.getAttribute("width"), 40 + 2*this.HORIZONTAL_MARGIN - 2)
                  assert.equal(rectElement.getAttribute("height"), 300)
                  done();
                })
            }.bind(this), this.timeout);
        })

        test ('long track to the left on background should create a Rectangle with text inside', function (done) {
            setTimeout(function () {
                let imageElement = new GesturesListenerElement(this._element.shadowRoot.querySelector('svg>image'));
                imageElement.longTapAt(200,100, () => {
                  imageElement.trackAt(200,100).moveTo(50,100).stop();
                  let textElement = this._element.shadowRoot.querySelector("svg>g>text")
                  assert.equal(textElement.innerHTML, "rectangle");
                  assert.equal(textElement.getAttribute("x"), 200 - 150 - this.leftMargin + 10 - this.HORIZONTAL_MARGIN); // 10 = left margin in rect
                  let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
                  assert.equal(rectElement.getAttribute("x"), 200 - 150 - this.leftMargin - this.HORIZONTAL_MARGIN)
                  assert.equal(rectElement.getAttribute("y"), 25)
                  assert.equal(rectElement.getAttribute("width"), 150 + 2*this.HORIZONTAL_MARGIN - 2)
                  assert.equal(rectElement.getAttribute("height"), 300)
                  done();
                })
            }.bind(this), this.timeout);
        })

        test ('long track to the left and go back to the right to the origin on background should create a Rectangle and then an VerticalLine', function (done) {
            setTimeout(function () {
                let imageElement = new GesturesListenerElement(this._element.shadowRoot.querySelector('svg>image'));
                imageElement.longTapAt(200,100, () => {
                  imageElement.trackAt(200,100).moveTo(220,100).moveTo(200,100).stop();
                  let textElement = this._element.shadowRoot.querySelector("svg>g>text")
                  assert.equal(textElement.innerHTML, "vline");
                  let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
                  assert.equal(rectElement.getAttribute("x"), 200 - VL_WIDTH/2 - this.leftMargin)
                  assert.equal(rectElement.getAttribute("y"), 25)
                  assert.equal(rectElement.getAttribute("width"), VL_WIDTH - 2)
                  assert.equal(rectElement.getAttribute("height"), 300 - VL_TEXT_HEIGHT)
                  done();
                })
            }.bind(this), this.timeout);
        })

        test ('long track to the left and go back to the right beyond the origin on background should create a Rectangle to the right and then to the left', function (done) {
            setTimeout(function () {
                let imageElement = new GesturesListenerElement(this._element.shadowRoot.querySelector('svg>image'));
                imageElement.longTapAt(200,100, () => {
                  imageElement.trackAt(200,100).moveTo(350,100).moveTo(50,100).stop()
                  let textElement = this._element.shadowRoot.querySelector("svg>g>text")
                  assert.equal(textElement.innerHTML, "rectangle");
                  assert.equal(textElement.getAttribute("x"), 200 - 150 - this.leftMargin + 10 - this.HORIZONTAL_MARGIN); // 10 = left margin in rect
                  let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
                  assert.equal(rectElement.getAttribute("x"), 200 - 150 - this.leftMargin - this.HORIZONTAL_MARGIN)
                  assert.equal(rectElement.getAttribute("y"), 25)
                  assert.equal(rectElement.getAttribute("width"), 150 + 2*this.HORIZONTAL_MARGIN - 2)
                  assert.equal(rectElement.getAttribute("height"), 300)
                  done();
                })
            }.bind(this), this.timeout);
        })

        test ('long track to the right and go back to the left to the origin on background should create a Rectangle and then an VerticalLine', function (done) {
            setTimeout(function () {
                let imageElement = new GesturesListenerElement(this._element.shadowRoot.querySelector('svg>image'));
                imageElement.longTapAt(200,100, () => {
                  imageElement.trackAt(200,100).moveTo(180,100).moveTo(200,100).stop();
                  let textElement = this._element.shadowRoot.querySelector("svg>g>text")
                  assert.equal(textElement.innerHTML, "vline");
                  let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
                  assert.equal(rectElement.getAttribute("x"), 200 - VL_WIDTH/2 - this.leftMargin)
                  assert.equal(rectElement.getAttribute("y"), 25)
                  assert.equal(rectElement.getAttribute("width"), VL_WIDTH - 2)
                  assert.equal(rectElement.getAttribute("height"), 300 - VL_TEXT_HEIGHT)
                  done();
                })
            }.bind(this), this.timeout);
        })

        test ('long track to the right and go back to the left beyond the origin on background should create a Rectangle to the left and then to the right', function (done) {
            setTimeout(function () {
                let imageElement = new GesturesListenerElement(this._element.shadowRoot.querySelector('svg>image'));
                imageElement.longTapAt(200,100, () => {
                  imageElement.trackAt(200,100).moveTo(50,100).moveTo(350,100).stop();
                  let textElement = this._element.shadowRoot.querySelector("svg>g>text")
                  assert.equal(textElement.innerHTML, "rectangle");
                  assert.equal(textElement.getAttribute("x"), 200 - this.leftMargin + 10 - this.HORIZONTAL_MARGIN); // 10 = left margin in rect
                  let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
                  assert.equal(rectElement.getAttribute("x"), 200 - this.leftMargin - this.HORIZONTAL_MARGIN)
                  assert.equal(rectElement.getAttribute("y"), 25)
                  assert.equal(rectElement.getAttribute("width"), 150 + 2*this.HORIZONTAL_MARGIN - 2)
                  assert.equal(rectElement.getAttribute("height"), 300)
                  done();
                })
            }.bind(this), this.timeout);
        })

    });

    </script>

  </body>
</html>
